<script setup lang="ts">
import { ref, useAttrs, onMounted, watch } from "vue";
import type { QTableProps } from "quasar";
import router from "@/router";
import { useCounterMixin } from "@/stores/mixin";
import { useQuasar } from "quasar";
import { useEvaluateMeetingDataStore } from "@/modules/12_evaluatePersonal/store/MeetingStore";
import http from "@/plugins/http";
import config from "@/app.config";

const $q = useQuasar();
const dataStore = useEvaluateMeetingDataStore();
const mixin = useCounterMixin();
const {
  messageError,
  showLoader,
  hideLoader,
  dialogConfirm,
  dialogRemove,
  success,
} = mixin;

const currentPage = ref<number>(1);
const maxPage = ref<number>(1);
const page = ref<number>(1);
const rowsPerPage = ref<number>(10);

/**
 *pagination ของตาราง
 */
const pagination = ref({
  descending: false,
  page: page.value,
  rowsPerPage: rowsPerPage.value,
});

watch(
  () => currentPage.value,
  () => {
    rowsPerPage.value = pagination.value.rowsPerPage;
    getList();
  }
);

watch(
  () => pagination.value.rowsPerPage,
  () => {
    rowsPerPage.value = pagination.value.rowsPerPage;
    currentPage.value = 1;
    getList();
  }
);
async function getList() {
  showLoader();
  await http
    .get(
      config.API
        .meeting
        // currentPage.value,
        // rowsPerPage.value,
        // filterKeyword.value
        ()
    )
    .then((res) => {
      // maxPage.value = Math.ceil(res.data.result.total / rowsPerPage.value);
      const data = res.data.result;
      dataStore.fetchData(data);
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ลบข้อมูล
 * @param id ไอดีของข้อมูล
 */
function clickDelete(id: string) {
  dialogRemove($q, async () => deleteData(id), `ลบข้อมูล`);
}

/**
 * ลบข้อมูล
 * @param id type
 */
async function deleteData(id: string) {
  console.log(id);
  showLoader();
  await http
    .delete(config.API.meetingById(id))
    .then((res) => {
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      await getList();
    });
}

/**เมื่อเริ่มโหลดหน้า
 * ส่งข้อมูลจำลองไปยัง store
 */
onMounted(() => {
  getList();
  // get ข้อมูลแล้วโยนใส่ store
});

/**
 * ค้นหาในตาราง
 */
const filterKeyword = ref<string>("");
const filterRef = ref<HTMLInputElement | null>(null);
function resetFilter() {
  filterKeyword.value = "";
  if (filterRef.value) {
    filterRef.value.focus();
  }
}

function filterFn() {
  getList();
  console.log("enter", filterKeyword.value);
}
</script>
<template>
  <div class="toptitle text-dark col-12 row items-center">รายการการประชุม</div>
  <q-card flat bordered class="col-12 q-mt-sm q-pa-md">
    <div class="row col-12 q-col-gutter-sm q-mb-sm">
      <div>
        <q-btn
          @click="router.push(`/evaluate/meeting/add`)"
          size="12px"
          flat
          round
          color="add"
          icon="mdi-plus"
        >
          <q-tooltip>เพิ่มการประชุม</q-tooltip>
        </q-btn>
      </div>
      <q-space />

      <q-input
        class="col-xs-12 col-sm-3 col-md-2"
        standout
        dense
        v-model="filterKeyword"
        ref="filterRef"
        outlined
        debounce="300"
        placeholder="ค้นหา"
        @keydown.enter.prevent="filterFn"
      >
        <template v-slot:append>
          <q-icon v-if="filterKeyword == ''" name="search" />
          <q-icon
            v-if="filterKeyword !== ''"
            name="clear"
            class="cursor-pointer"
            @click="resetFilter"
          />
        </template>
      </q-input>

      <q-select
        v-model="dataStore.visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="dataStore.columns"
        option-value="name"
        options-cover
        style="min-width: 150px"
        class="col-xs-12 col-sm-3 col-md-2"
      />
    </div>

    <div class="col-12">
      <d-table
        :columns="dataStore.columns"
        :rows="dataStore.rows"
        :filter="filterKeyword"
        row-key="tb-list"
        flat
        bordered
        :paging="true"
        dense
        v-model:pagination="pagination"
        :visible-columns="dataStore.visibleColumns"
      >
        <template v-slot:pagination="scope">
          <q-pagination
            v-model="currentPage"
            active-color="primary"
            color="dark"
            :max="Number(maxPage)"
            size="sm"
            boundary-links
            direction-links
          ></q-pagination>
        </template>
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
            <q-th auto-width />
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props" class="cursor-pointer">
            <q-td
              v-for="col in props.cols"
              :key="col.name"
              :props="props"
              @click="router.push(`/evaluate/meeting/${props.row.id}`)"
            >
              <div v-if="col.name == 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div v-else>
                {{ col.value }}
              </div>
            </q-td>
            <q-td auto-width>
              <q-btn
                dense
                size="12px"
                flat
                round
                color="red"
                @click="clickDelete(props.row.id)"
                icon="mdi-delete"
              >
                <q-tooltip>ลบข้อมูล</q-tooltip>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </d-table>
    </div>
  </q-card>
</template>
